#!/bin/sh

echo -e "\nInterface\tChipset\t\tDriver\n"

for iface in `iwconfig 2>/dev/null | egrep '(IEEE|ESSID)' | cut -b 1-7`
do

    ifconfig $iface up 2>/dev/null
    sleep 1

    chipset="Unknown\t"
    driver="Unknown"

    if [ x"`echo $iface | cut -b 1-3`" = "xath" ]
    then
        chipset="Atheros\t"
        driver="madwifi"
    fi

    if [ x"`echo $iface | cut -b 1-4`" = "xwifi" ]
    then
        continue
    fi

    if [ x"`echo $iface | cut -b 1-4`" = "xwlan" ]
    then
        if [ x"`wlancfg show $iface 2>/dev/null`" != "x" ]
        then
            chipset="Prism2\t"
            driver="wlan-ng"
            wlanctl-ng $iface lnxreq_ifstate ifstate=enable >/dev/null
            wlanctl-ng $iface lnxreq_wlansniff channel=10 enable=true \
                              prismheader=true wlanheader=false \
                              stripfcs=true keepwepflags=true >/dev/null
            echo p2CnfWEPFlags=0,4,7 | wlancfg set $iface
        else
            if [ x"`dmesg | grep \"netdevice $iface\"`" != "x" ]
            then
                chipset="Prism2\t"
                driver="HostAP"
            fi
        fi
    fi

    if [ x"`echo $iface | cut -b 1-3`" = "xeth" ]
    then
        if [ x"`dmesg | grep \"$iface: resetting device\"`" != "x" ]
        then
            chipset="PrismGT\t"
            driver="prism54"
        fi
        if [ x"`dmesg | grep \"$iface: Station identity\"`" != "x" ]
        then
            chipset="HermesI\t"
            driver="orinoco"
            iwpriv $iface monitor 1 10 2>/dev/null
        fi
        if [ x"`dmesg | grep ipw2100`" != "x" ]
        then
            chipset="Centrino"
            driver="ipw2100"
        fi
        if [ x"`dmesg | grep ipw2200`" != "x" ]
        then
            chipset="Centrino"
            driver="ipw2200"
        fi
    fi

    iwconfig $iface mode Monitor channel 10 2>/dev/null
    ifconfig $iface up 2>/dev/null

    echo -e "$iface\t\t$chipset\t$driver"

done

echo

